Hooks:PostHook( NewRaycastWeaponBase, "_update_stats_values", "nmsfwMod_update_stats_values", function(self, disallow_replenish)
	if not self._current_stats then
		return
	end

	local parts_stats = managers.weapon_factory:get_stats(self._factory_id, self._blueprint)
	if parts_stats.extra_ammo_new then
		self._extra_ammo = ( ( parts_stats.extra_ammo or 0 ) + parts_stats.extra_ammo_new ) or self._extra_ammo
	end
	if parts_stats.total_ammo_mod_new then
		self._extra_ammo = ( ( parts_stats.total_ammo_mod or 0 ) + parts_stats.total_ammo_mod_new ) or self._total_ammo_mod
	end

	if not disallow_replenish then
		self:replenish()
	end
end)